#bcond_with test
%define with_test 0
#bcond_without bootstrap
%define with_bootstrap 1
%define section free

Summary:        XML Pull Parser
Name:           xom
Version:        1.2.1
Release:        5
Epoch:          0
License:        LGPL
URL:            http://www.xom.nu/
Group:          Development/Java
Source0:        http://www.cafeconleche.org/XOM/xom-1.2.1-src.tar.gz
Source1:        xom-1.2.1.pom
Patch0:         xom-1.2.1-remove_jaxen.patch
Patch1:         xom-1.1-clean-dist.patch
Patch2:         xom-1.1-compile15.patch
Patch3:         xom-1.1-remove_sun_import.patch
Patch4:         xom-1.1-build.patch
Patch5:         xom-1.1-sinjdoc.patch
Patch6:         xom-1.0-betterdocclasspath.patch
Patch7:         xom-1.2.1-gjdocissues.patch
Patch8:         xom-1.2.1-javadoc-stack-size.patch
Patch9:         xom-1.2.1-crosslinks.patch
Patch10:        xom-1.2.1-betterdoc-stack-size.patch

BuildRequires:  java-rpmbuild >= 0:1.6
BuildRequires:  java-javadoc
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit
BuildRequires:  jaxen >= 1.1.2-1.3
BuildRequires:  junit
BuildRequires:  junit-javadoc
BuildRequires:  xalan-j2
BuildRequires:  xerces-j2
BuildRequires:  icu4j
BuildRequires:  xml-commons-jaxp-1.3-apis

%if !%with_bootstrap
BuildRequires:  tagsoup
BuildRequires:  saxon
BuildRequires:  saxon-aelfred
BuildRequires:  jaxp_parser_impl
#BuildRequires:  xml-commons-resolver12
BuildRequires:  xml-commons-resolver
BuildRequires:  servletapi5
%endif
Requires:  xalan-j2
Requires:  xerces-j2
Requires:  icu4j
Requires:  jaxen >= 1.1.2-1.3
Requires:  xml-commons-jaxp-1.3-apis
BuildArch:      noarch
BuildRequires:  java-devel


%description
XOM is a new XML object model. It is an open source (LGPL), 
tree-based API for processing XML with Java that strives 
for correctness, simplicity, and performance, in that order. 
XOM is designed to be easy to learn and easy to use. It 
works very straight-forwardly, and has a very shallow 
learning curve. Assuming you're already familiar with XML, 
you should be able to get up and running with XOM very quickly.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Java

%description javadoc
XML Pull Parser.

%if !%with_bootstrap
%package demo
Summary:        Samples for %{name}
Group:          Development/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description demo
XML Pull Parser.
%endif

%prep
%setup -q -n XOM
# remove all binary libs
find . -name "*.jar" -o -name "*.class" | xargs -t rm
%patch0 -p0
%patch1 -p0
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1 -b .orig
%patch6 -p1
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0


%{__perl} -pi -e 's/\r$//g' *.html *.txt
%{__perl} -pi -e 's/compress="no"/compress="yes"/g' build.xml

%build
export CLASSPATH=$(build-classpath icu4j jaxen)
export OPT_JAR_LIST="ant/ant-junit"
pushd lib
ln -sf $(build-classpath junit) junit.jar
ln -sf $(build-classpath xerces-j2) xercesImpl.jar
ln -sf $(build-classpath xerces-j2) dtd-xercesImpl.jar
ln -sf $(build-classpath xalan-j2) xalan.jar
ln -sf $(build-classpath icu4j) normalizer.jar
ln -sf $(build-classpath xml-commons-jaxp-1.3-apis) xmlParserAPIs.jar
popd
mkdir lib2
%if !%with_bootstrap
pushd lib2
ln -sf $(build-classpath tagsoup) tagsoup-1.2.jar
ln -sf $(build-classpath saxon) saxon.jar
ln -sf $(build-classpath saxon-aelfred) saxon.jar
ln -sf $(build-classpath jaxp_parser_impl) gnujaxp.jar
#ln -sf $(build-classpath xml-commons-resolver12) resolver.jar
ln -sf $(build-classpath xml-commons-resolver) resolver.jar
DOM4J_PRESENT=$(build-classpath dom4j 2>/dev/null || :)
if [ -n "$DOM4J_PRESENT" ]; then
ln -sf $(build-classpath dom4j) dom4j-1.5.1.jar
fi
ln -sf $(build-classpath servletapi5) servlet.jar
popd

%endif

%if %with_bootstrap
ant \
  -Dant.build.javac.source=1.4 \
  -Dant.build.javac.target=1.4 \
  -Dbuild.sysclasspath=first \
  -Dj2se.api=%{_javadocdir}/java \
  -Djunit.api=%{_javadocdir}/junit \
  jar javadoc

%else

ant \
  -Dant.build.javac.source=1.4 \
  -Dant.build.javac.target=1.4 \
  -Dbuild.sysclasspath=first \
  -Dj2se.api=%{_javadocdir}/java \
  -Djunit.api=%{_javadocdir}/junit \
  jar samples betterdoc

%if %with_test
ant \
  -Dant.build.javac.source=1.4 \
  -Dant.build.javac.target=1.4 \
  -Dbuild.sysclasspath=first \
  test
%endif
%endif

pushd build/apidocs
  for f in `find -name \*.css -o -name \*.html`; do
    sed -i 's/\r//g' $f
  done
popd

%install
# jars
install -d -m 755 %{buildroot}%{_javadir}

install -m 644 build/%{name}-%{version}.jar \
  %{buildroot}%{_javadir}/%{name}-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -a build/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}


rm -rf doc/{build.txt,api,api_impl}

# docs
install -d -m 755 %{buildroot}%{_datadir}/doc/%{name}-%{version}
install -m 644 overview.html %{buildroot}%{_datadir}/doc/%{name}-%{version}
install -m 644 *.txt %{buildroot}%{_datadir}/doc/%{name}-%{version}

%if !%with_bootstrap
# demo
install -d -m 755 %{buildroot}%{_datadir}/%{name}-%{version}
install -m 644 build/xom-samples.jar %{buildroot}%{_datadir}/%{name}-%{version}
install -m 644 xom.graffle %{buildroot}%{_datadir}/%{name}-%{version}
%endif

%{_bindir}/find %{buildroot}%{_javadocdir}/%{name}-%{version} -type f | %{_bindir}/xargs -t %{__perl} -pi -e 's/\r$//g'

mkdir -p %{buildroot}%{_mavenpomdir}
install -pm 644 %{SOURCE1} %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_to_maven_depmap %{name} %{name} %{version} JPP %{name}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%{_datadir}/doc/%{name}-%{version}/overview.html
%{_datadir}/doc/%{name}-%{version}/README.txt
%{_datadir}/doc/%{name}-%{version}/LICENSE.txt
%{_datadir}/doc/%{name}-%{version}/Todo.txt
%{_datadir}/doc/%{name}-%{version}/lgpl.txt
%if !%with_bootstrap
%{_datadir}/%{name}-%{version}/xom.graffle
%endif
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*

%files javadoc
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if !%with_bootstrap
%files demo
%{_datadir}/%{name}-%{version}/xom-samples.jar
%endif

%changelog

* Mon Jun 15 2015 Denis Silakov <denis.silakov@rosalab.ru> 0:1.2.1-5
- (717fea7) Rebuild with Java8


